unit DataBaseConnectDBX;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,Buttons, ExtCtrls,StdCtrls,
  Forms, Dialogs, ComCtrls, Db,dbCtrls,QuickRpt,
  DBXpress, SqlExpr, FMTBcd, Provider, DBClient;

type

   TdmConnection = class(TDataModule)
    SQLConnection: TSQLConnection;
    GeneralLookupQuery: TSQLQuery;
    GeneralLookupCDS: TClientDataSet;
    GeneralLookupProvider: TDataSetProvider;
    procedure dmConnectionCreate(Sender: TObject);
    procedure dmConnectionDestroy(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
    WhereClause: String;
  end;


var
  dmConnection: TdmConnection;

procedure UpdateDescriptions(InitiatingField:TField;
  MasterFieldName,LookupKeyFieldName,LookupTableName:String;
  FieldMapping:Array of String;MasterDataSet:TDataset );
procedure UpdateDescriptionsComposite(InitiatingField:TField;
  MasterFieldName,LookupKeyFieldName,LookupTableName:String;
  FieldMapping:Array of String;MasterDataSet:TDataset );
procedure LookupDialog(LookupTableName:String;
  FieldMapping:Array of String;MasterDataSet:TDataset );
procedure DoValidation(Sender:TField;FieldName,DisplayName:String;
  unique,primary,required,foreign:Boolean;check:string) ;
procedure SetSearch( F:TForm);
procedure PrintReport(MasterQuery,DetailQuery:TQuery;ReportForm:Tform;FType:TFormClass);
procedure PreviewReport(MasterQuery,DetailQuery:TQuery;ReportForm:Tform;FType:TFormClass);


implementation

uses LookupForm;

{$R *.DFM}
procedure UpdateDescriptions(InitiatingField:TField;
  MasterFieldName,LookupKeyFieldName,LookupTableName:String;
  FieldMapping:Array of String;MasterDataSet:TDataset );
var i:integer;
  QueryText,FieldVal:String;
begin
  with dmConnection do begin
    if  InitiatingField=nil then exit;
    if  InitiatingField.FieldName<>MasterFieldName then exit;
    if (length(fieldmapping)<2) then exit;
    if (length(fieldmapping) mod 2 <>0) then exit;
    querytext:='';
    for i:=0 to (length(fieldmapping)-2) div 2 do begin
      if querytext='' then querytext:=fieldmapping[i*2]
      else querytext:=querytext+','+fieldmapping[i*2]
    end;
    querytext:='SELECT '+querytext+' FROM '+lookuptablename;
    case InitiatingField.DataType of
      ftString,ftFixedChar,ftWideString,ftDate, ftTime, ftDateTime: begin
         FieldVal:=''''+InitiatingField.AsString+'''';
      end;
      ftSmallint, ftInteger, ftWord,ftBoolean, ftLargeint: begin
        str(InitiatingField.AsInteger,Fieldval);
      end;
      ftFloat, ftCurrency, ftBCD: begin
        str(InitiatingField.AsFloat,Fieldval);
      end
      else exit;
    end;
    querytext:=querytext+' WHERE '+LookupKeyFieldName+'='+FieldVal;
    try
      GeneralLookupQuery.SQL.Clear;
      GeneralLookupQuery.SQL.Add(querytext);
      GeneralLookupQuery.Open;
    if GeneralLookupQuery.IsEmpty then begin
      InitiatingField.tag:=-1;
      ShowMessage('Not found');
    end
    else begin
      if not(MasterDataSet.State in [dsEdit,dsInsert]) then
        MasterDataSet.Edit;
      for i:=0 to (length(fieldmapping)-2) div 2 do begin
         MasterDataSet.FieldByName(fieldmapping[i*2+1]).Value:=
            GeneralLookupQuery.FieldByName(fieldmapping[i*2]).Value;
      end;
      InitiatingField.tag:=0;
    end;
    GeneralLookupQuery.Close;
    except
      InitiatingField.tag:=-1;
      GeneralLookupQuery.Close;
      Exit;
    end;

  end
end;

procedure UpdateDescriptionsComposite(InitiatingField:TField;
  MasterFieldName,LookupKeyFieldName,LookupTableName:String;
  FieldMapping:Array of String;MasterDataSet:TDataset );
var i:integer;
  QueryText,selectlist,wherelist,FieldVal:String;
  MasterField:TField;
begin
  with dmConnection do begin
    if  InitiatingField=nil then exit;
    if  InitiatingField.FieldName<>MasterFieldName then exit;
    if (length(fieldmapping)<3) then exit;
    if (length(fieldmapping) mod 3 <>0) then exit;
    case InitiatingField.DataType of
      ftString,ftFixedChar,ftWideString,ftDate, ftTime, ftDateTime: begin
         FieldVal:=''''+InitiatingField.AsString+'''';
      end;
      ftSmallint, ftInteger, ftWord,ftBoolean, ftLargeint: begin
        str(InitiatingField.AsInteger,Fieldval);
      end;
      ftFloat, ftCurrency, ftBCD: begin
        str(InitiatingField.AsFloat,Fieldval);
      end
      else exit;
    end;
    wherelist:='('+LookupKeyFieldName+'='+FieldVal+')';
    selectlist:='';
    for i:=0 to (length(fieldmapping)-3) div 3 do begin
      if fieldmapping[i*3+2]='L' then begin
        if selectlist='' then selectlist:=fieldmapping[i*3]
        else selectlist:=selectlist+','+fieldmapping[i*3]
      end
      else begin
        MasterField:=MasterDataSet.FieldByName(fieldmapping[i*3+1]);
        case MasterField.DataType of
          ftString,ftFixedChar,ftWideString,ftDate, ftTime, ftDateTime: begin
             FieldVal:=''''+MasterField.AsString+'''';
          end;
          ftSmallint, ftInteger, ftWord,ftBoolean, ftLargeint: begin
            str(MasterField.AsInteger,Fieldval);
          end;
          ftFloat, ftCurrency, ftBCD: begin
            str(MasterField.AsFloat,Fieldval);
          end
          else exit;
        end;
        wherelist:=wherelist+' AND ('+fieldmapping[i*3]+'='+FieldVal+')'
      end;
    end;
    querytext:='SELECT '+selectlist+' FROM '+lookuptablename;
    querytext:=querytext+' WHERE '+wherelist;
    try
      GeneralLookupQuery.SQL.Clear;
      GeneralLookupQuery.SQL.Add(querytext);
      GeneralLookupQuery.Open;
    if GeneralLookupQuery.IsEmpty then begin
      InitiatingField.tag:=-1;
      ShowMessage('Not found');
    end
    else begin
      if not(MasterDataSet.State in [dsEdit,dsInsert]) then
        MasterDataSet.Edit;
      for i:=0 to (length(fieldmapping)-3) div 3 do begin
        if fieldmapping[i*3+2]='L' then
         MasterDataSet.FieldByName(fieldmapping[i*3+1]).Value:=
            GeneralLookupQuery.FieldByName(fieldmapping[i*3]).Value;
      end;
      InitiatingField.tag:=0;
    end;
    GeneralLookupQuery.Close;
    except
      InitiatingField.tag:=-1;
      GeneralLookupQuery.Close;
      Exit;
    end;

  end

end;
procedure LookupDialog(LookupTableName:String;
  FieldMapping:Array of String;MasterDataSet:TDataset );
var i:integer;
  QueryText:String;
  SearchMode: Boolean;
begin
  with dmConnection do begin
    if (length(fieldmapping)<3) or (length(fieldmapping) mod 3 <>0) then exit;
    querytext:='';
    for i:=0 to (length(fieldmapping)-3) div 3 do begin
      if querytext='' then querytext:=fieldmapping[i*3+1]
      else querytext:=querytext+','+fieldmapping[i*3+1]
    end;
    querytext:='SELECT '+querytext+' FROM '+lookuptablename;
    Application.CreateForm(TFrmLookupForm,frmLookupForm);
    frmLookupForm.DataSource1.Dataset:=GeneralLookupQuery;

    try
      GeneralLookupQuery.Close;
      GeneralLookupQuery.SQL.Clear;
      GeneralLookupQuery.SQL.Add(querytext);
      GeneralLookupQuery.Open;
      for i:=0 to (length(fieldmapping)) div 3 - 1 do
        frmLookupForm.DBGrid1.Columns[i].title.caption:= fieldmapping[i*3+2] ;
    except
      GeneralLookupQuery.Close;
      Exit;
    end;
    if frmLookupForm.ShowModal=mrOK then begin
      if not(MasterDataSet.State in [dsEdit,dsInsert]) then
        MasterDataSet.Edit;
      MasterDataSet.DisableControls;
      if GeneralLookupQuery.isEmpty then
        ShowMessage('Not found');
      if (MasterDataSet.Tag and 2)<>0 then
        SearchMode:=True
      else
        SearchMode:=false;
      if not(SearchMode) then begin
        for i:=0 to (length(fieldmapping)-3) div 3 do begin
           if GeneralLookupQuery.isEmpty then begin
             MasterDataSet.FieldByName(uppercase(fieldmapping[i*3])).tag:=-1;
           end
           else begin
             MasterDataSet.FieldByName(uppercase(fieldmapping[i*3])).Value:=
                GeneralLookupQuery.FieldByName(uppercase(fieldmapping[i*3+1])).Value;
             MasterDataSet.FieldByName(uppercase(fieldmapping[i*3])).tag:=0;
           end
        end;
        GeneralLookupQuery.Close;
      end;
    end;
    frmLookupForm.Destroy;
    MasterDataSet.EnableControls;

  end
end;

procedure DoValidation(Sender:TField;FieldName,DisplayName:String;
  unique,primary,required,foreign:Boolean;check:string);
var
  fvalue:String;
  exists:boolean;
  DataSet:TDataSet;
begin
  if not(assigned(Sender)) then exit;
  if sender.FieldName<>FieldName then exit;
  DataSet:=Sender.DataSet;
  if (DataSet.ControlsDisabled) then exit ;
  
  if not(DataSet.State in [dsInsert,dsEdit]) then Exit;
  if (Required OR Primary) and (DataSet.FieldByName(FieldName).IsNull) then begin
    ShowMessage('Value for '+DisplayName+' must be entered!');
    Abort;
    Exit;
  end;
  if (trim(check)<>'') and (unique or primary or foreign) then begin
    try
      Exists:=false;
      dmConnection.GeneralLookupQuery.Close;
      dmConnection.GeneralLookupQuery.SQL.Clear;
      dmConnection.GeneralLookupQuery.SQL.Add(check);
     case DataSet.FieldByName(FieldName).DataType of
      ftDate,ftDateTime:
      begin
       if SQLConnection.DriverName='Oracle' then
         fvalue := ' TO_DATE('+#39+DateToStr(dmConnection.VarToDate(DataSet.FieldByName(FieldName).Value))+#39+','+#39+'dd/mm/yyyy'+#39+')'
       else
         if SQLConnection.DriverName='Interbase' then
           fvalue := ' CAST('+#39+dmConnection.DateToIBDateStr(dmConnection.VarToDate(DataSet.FieldByName(FieldName).Value))+#39+' AS DATE)'
         else
           fvalue := #39+DateToStr(dmConnection.VarToDate(DataSet.FieldByName(FieldName).Value))+#39;
      end;
      ftString,ftWideString,ftFixedChar:
         fvalue:=''''+DataSet.FieldByName(FieldName).AsString+'''';
      else
         fvalue:=DataSet.FieldByName(FieldName).AsString;
     end;
     dmConnection.GeneralLookupQuery.SQL.Add(fvalue);
     dmConnection.GeneralLookupQuery.Open;
     Exists:=not(dmConnection.GeneralLookupQuery.IsEmpty);
    finally
      dmConnection.GeneralLookupQuery.Close;
    end ;
    if exists and (unique or primary) and (dataset.State=dsInsert) then begin
      ShowMessage('Value for '+DisplayName+' already exists!');
       Abort;
       Exit;
    end;
    if (not(exists)) and (foreign) then begin
      ShowMessage('Lookup value for '+DisplayName+' does not exist!');
      Abort;
      Exit;
    end;
  end;

end;

function EliminateSingleQuotes(st:String):String;
var st1:String;
  i:integer;
begin
  st1:='';
  for i:=1 to length(st) do begin
    st1:=st1+st[i];
    if st[i]='''' then st1:=st1+''''
  end;
  EliminateSingleQuotes:=st1;
end;

function CleanupNumber(st:String):String;
var st1:String;
  i:integer;
  usednumber,usedsign,usedcomma:Boolean;
begin
  st1:='';
  usednumber:=false;
  usedsign:=false;
  usedcomma:=false;
  for i:=1 to length(st) do begin
    if st[i] in ['0'..'9'] then begin
      st1:=st1+st[i];
      usednumber:=true;
    end;
    if st[i] in ['+','-'] then begin
      if (not(usedsign)) and (not(usednumber)) then begin
        st1:=st1+st[i];
        usedsign:=true;
      end;
    end;
    if st[i] in ['.',','] then begin
      if (not(usedcomma)) and (usednumber) then begin
        st1:=st1+'.';
        usedcomma:=true;
      end;
    end;
  end;
  if not(usednumber) then st1:='0';
  CleanUpNumber:=St1;
end;

function DBMSDate(st:String):String;
var gotdate:TDateTime;
  y,m,d:word;
  protocol:String;
begin
  try
    gotdate:=StrToDate(st);
  except
    gotdate:=now;
    ShowMessage('Wrong date format. Assumed today.');
  end;
  DecodeDate(gotDate,Y,M,D);
  Result := IntToStr(D)+#46+IntToStr(M)+#58+IntToStr(Y);
  Protocol:= SQLConnection.DriverName;
  if protocol='Oracle' then
    DBMSDate:='TO_DATE('+#39+inttostr(d)+'/'+inttostr(m)+'/'+inttostr(y)+#39+
  ','+#39+'dd/mm/yyyy'+#39+')'
  else if (protocol='Interbase') then
    DBMSDate:='CAST('+#39+IntToStr(D)+#46+IntToStr(M)+#58+IntToStr(Y)+#39+' AS DATE)'
  else
    DbmsDate:=#39+inttostr(d)+'/'+inttostr(m)+'/'+inttostr(y)+#39;
end;
procedure SetSearch( F:TForm);
var i,j,ModifyWhich,TotModifications:Integer;
  ComponentList:Array of TComponent;
  SearchMode,FoundModifiedQuery,WhereFound:Boolean;
  SrchEdit:TEdit;
  CorrespondingEdit:TDBEdit;
  Modifications:Array of record
    WhereText:String;
    ModifiedQuery:TQuery
  end;
  QueryText,FieldName,EnteredAsk,FromAsk,ToAsk:String;
  QPos,QEnd,TagOrVal,FNPos,WhPos: Integer;
  FoundField:TField;
begin
  SetLength(ComponentList,F.ComponentCount);
  SearchMode:=false;
  TotModifications:=0;
  for i:=0 to F.ComponentCount-1 do begin
     ComponentList[i]:=F.Components[i];
     if copy(ComponentList[i].name,1,5)='_find' then SearchMode:=true;
  end;
  LockWindowUpdate(F.Handle);
  for i:=0 to F.ComponentCount-1 do
  begin
    if SearchMode then Begin
      if (ComponentList[i] is TDataSource) then
        (ComponentList[i] as TDataSource).Enabled:=true;
      if (ComponentList[i] is TToolButton) and
        (pos('FindButton',ComponentList[i].name)=0) then
          (ComponentList[i] as TToolButton).Enabled:=true;

      if (ComponentList[i] is TDbEdit) then begin
        (ComponentList[i] as TDbEdit).visible:=true;
      end;
      ModifyWhich:=0;
      if copy(ComponentList[i].name,1,5)='_find' then begin
         CorrespondingEdit:=F.FindComponent
           (copy(ComponentList[i].name,6,length(ComponentList[i].name)))
           as TDBEdit;
            FoundModifiedQuery:=False;
            for j:=0 to TotModifications-1 do begin
             if CorrespondingEdit.DataSource<>nil then
              if CorrespondingEdit.DataSource.DataSet=Modifications[j].ModifiedQuery then begin
                FoundModifiedQuery:=true;
                ModifyWhich:=j;
              end;
            end;
            if not(FoundModifiedQuery) then begin
              ModifyWhich:=TotModifications;
              TotModifications:=TotModifications+1;
              SetLength(Modifications,TotModifications);
              if CorrespondingEdit.DataSource<>nil then
                Modifications[ModifyWhich].ModifiedQuery:=
                  CorrespondingEdit.DataSource.DataSet as TQuery;
            end;
            With Modifications[ModifyWhich] do begin
             whpos:=pos('WHERE',uppercase(ModifiedQuery.SQL.Text));
             if whpos=0 then begin
               whpos:=pos('ORDER BY',uppercase(ModifiedQuery.SQL.Text));
               if whpos=0 then
                 whpos:=length(ModifiedQuery.SQL.Text);
             end;
             EnteredAsk:=(ComponentList[i] as TEdit).Text;
             if pos('...',EnteredAsk)>0 then begin
                FromAsk:=Copy(EnteredAsk,1,pos('...',EnteredAsk)-1);
                ToAsk:=Copy(EnteredAsk,pos('...',EnteredAsk)+3,length(EnteredAsk));
             end
             else begin
                FromAsk:=EnteredAsk;
                ToAsk:=EnteredAsk;
              end;
             if trim((ComponentList[i] as TEdit).Text)<>'' then begin
              FieldName:=(CorrespondingEdit as TDbEdit).DataField;
              FNPos:=pos(' AS '+uppercase(FieldName),uppercase(ModifiedQuery.Sql.Text));
              if FNPos=0 then
                FNPos:=pos(' '+uppercase(FieldName),uppercase(ModifiedQuery.Sql.Text));
              if (fnpos<>0) and (fnpos<whpos) then begin
                FieldName:='';
                FNPos:=FNPos-1;
                while (FNPos>1) and (ModifiedQuery.SQL.Text[FNPos] in
                ['a'..'z','_','A'..'Z','0'..'9','.','"']) do begin
                  FieldName:=ModifiedQuery.SQL.Text[FNPos]+FieldName;
                  FNPos:=FNPos-1;
                end;
              end;

              if WhereText<>'' then WhereText:=WhereText+' AND ';
              FoundField:=
                F.FindComponent(
                CorrespondingEdit.DataSource.DataSet.Name+
                (CorrespondingEdit as TDbEdit).DataField )
                as TField;
              if FoundField<>nil then begin
                if fromAsk=toAsk then
                  case FoundField.DataType of
                    ftUnknown, ftString, ftMemo,ftFmtMemo, ftFixedChar,
                    ftWideString: WhereText:=WhereText+
                      FieldName+'='''+EliminateSingleQuotes(
                      FromAsk)+'''';
                    ftSmallint, ftInteger, ftWord,ftBoolean, ftFloat,
                    ftCurrency, ftBCD, ftAutoInc, ftLargeint: begin
                      WhereText:=WhereText+
                      FieldName+'='+CleanUpNumber(
                      FromAsk);
                    end;
                    ftDate, ftTime, ftDateTime{,ftTimeStamp}:
                      WhereText:=WhereText+
                      FieldName+'='+DBMSDate(FromAsk);
                  end
                else
                if (fromAsk='') and (toAsk<>'') then
                  case FoundField.DataType of
                    ftUnknown, ftString, ftMemo,ftFmtMemo, ftFixedChar,
                    ftWideString: WhereText:=WhereText+
                      FieldName+'<='''+EliminateSingleQuotes(
                      ToAsk)+'''';
                    ftSmallint, ftInteger, ftWord,ftBoolean, ftFloat,
                    ftCurrency, ftBCD, ftAutoInc, ftLargeint: begin
                      WhereText:=WhereText+
                      FieldName+'<='+CleanUpNumber(
                      ToAsk);
                    end;
                    ftDate, ftTime, ftDateTime{,ftTimeStamp}:
                      WhereText:=WhereText+
                      FieldName+'<='+DBMSDate(ToAsk);
                  end else
                if (fromAsk<>'') and (toAsk='') then
                  case FoundField.DataType of
                    ftUnknown, ftString, ftMemo,ftFmtMemo, ftFixedChar,
                    ftWideString: WhereText:=WhereText+
                      FieldName+'>='''+EliminateSingleQuotes(
                      FromAsk)+'''';
                    ftSmallint, ftInteger, ftWord,ftBoolean, ftFloat,
                    ftCurrency, ftBCD, ftAutoInc, ftLargeint: begin
                      WhereText:=WhereText+
                      FieldName+'>='+CleanUpNumber(
                      FromAsk);
                    end;
                    ftDate, ftTime, ftDateTime{,ftTimeStamp}:
                      WhereText:=WhereText+
                      FieldName+'>='+DBMSDate(FromAsk);
                  end else
                if (fromAsk<>'') and (toAsk<>'') then
                  case FoundField.DataType of
                    ftUnknown, ftString, ftMemo,ftFmtMemo, ftFixedChar,
                    ftWideString: WhereText:=WhereText+
                      FieldName+'>='''+EliminateSingleQuotes(
                      FromAsk)+''' AND '+
                      FieldName+'<='''+EliminateSingleQuotes(
                      ToAsk)+'''';
                    ftSmallint, ftInteger, ftWord,ftBoolean, ftFloat,
                    ftCurrency, ftBCD, ftAutoInc, ftLargeint: begin
                      WhereText:=WhereText+
                      FieldName+'>='+CleanUpNumber(
                      FromAsk)+' AND '+ FieldName+'<='+CleanUpNumber(
                      ToAsk);
                    end;
                    ftDate, ftTime, ftDateTime{,ftTimeStamp}:
                      WhereText:=WhereText+
                      FieldName+'>='+DBMSDate(FromAsk)+' AND '+
                      FieldName+'<='+DBMSDate(ToAsk);
                  end
               end
              else begin
                if fromask=toask then WhereText:=WhereText+
                  FieldName+'='''+EliminateSingleQuotes(FromAsk)+''''
                else
                if (fromask='') and (toask<>'') then WhereText:=WhereText+
                  FieldName+'<='''+EliminateSingleQuotes(ToAsk)+''''
                else
                if (fromask<>'') and (toask='') then WhereText:=WhereText+
                  FieldName+'>='''+EliminateSingleQuotes(FromAsk)+''''
                else
                if (fromask<>'') and (toask<>'') then WhereText:=WhereText+
                  FieldName+'>='''+EliminateSingleQuotes(FromAsk)+''' AND '+
                  FieldName+'<='''+EliminateSingleQuotes(ToAsk)+''''
              end;
             end
            end;
         ComponentList[i].Free;
      end;
    end
    else Begin
      if (ComponentList[i] is TDataSource) then
       (ComponentList[i] as TDataSource).Enabled:=false;
      if (ComponentList[i] is TToolButton) and
        (pos('FindButton',ComponentList[i].name)=0) then
          (ComponentList[i] as TToolButton).Enabled:=false;
      if (ComponentList[i] is TDbEdit) then begin
        (ComponentList[i] as TDbEdit).visible:=false;
        SrchEdit:=TEdit.Create(F);
        SrchEdit.Parent:=(ComponentList[i] as TDbEdit).Parent;
        SrchEdit.Visible:=True;
        SrchEdit.Top:=(ComponentList[i] as TDbEdit).Top;
        SrchEdit.Left:=(ComponentList[i] as TDbEdit).Left;
        SrchEdit.Height:=(ComponentList[i] as TDbEdit).Height;
        SrchEdit.Width:=(ComponentList[i] as TDbEdit).Width;
        SrchEdit.Color:=clAqua;
        SrchEdit.Name:='_find'+(ComponentList[i] as TDbEdit).Name;
         SrchEdit.Text:='';
      end;
    end;
  end;
 LockWindowUpdate(0);
 for j:=0 to TotModifications-1 do
 if Modifications[j].ModifiedQuery<>nil then begin
   if SearchMode then begin  // Kada se promijeni upit, u Tag se upise odakle
     QueryText:=Modifications[j].ModifiedQuery.Sql.Text;
     Qpos:= (Modifications[j].ModifiedQuery.Tag shr 2) and $FFF;
     QEnd:= (Modifications[j].ModifiedQuery.Tag shr 14) and $FFF;
//     ShowMessage('Stari:'+inttostr(qpos)+' '+inttostr(qend)+
//     ' '+copy(querytext,qpos,qend-qpos+1));

     if (QPos<>QEnd) then
       QueryText:=Copy(QueryText,1,Qpos)+Copy(QueryText,QEnd,Length(QueryText));
     whpos:=pos('WHERE',uppercase(QueryText));

     if whpos=0 then begin
       whpos:=pos('ORDER BY',uppercase(QueryText));
       if whpos=0 then
         whpos:=length(QueryText);
       wherefound:=false;
     end
     else
       wherefound:=true;
     if wherefound then
       Qpos:=whpos+5
     else
       Qpos:=whpos;

     QEnd:=QPos;

     if Modifications[j].WhereText<>'' then begin
       if not(wherefound) then begin
         QueryText:=Copy(QueryText,1,Qpos-1)+' '
          +'WHERE '+Modifications[j].WhereText+' '+
          Copy(QueryText,Qpos,Length(QueryText));
         QEnd:=(Qpos+Length(Modifications[j].WhereText)+7);
       end
       else begin
         QueryText:=Copy(QueryText,1,Qpos-1)+' '+
          Modifications[j].WhereText+' AND '+
          Copy(QueryText,Qpos,Length(QueryText));
         QEnd:=(Qpos+Length(Modifications[j].WhereText)+5);
       end
     end;
//     ShowMessage(inttostr(qpos)+' '+inttostr(qend)+
//     ' '+copy(querytext,qpos,qend-qpos+1));
     Modifications[j].ModifiedQuery.Tag:=Modifications[j].ModifiedQuery.Tag and 1;
     TagOrVal:=QPos or (QEnd shl 12);
     TagOrVal:=TagOrVal shl 2;
     Modifications[j].ModifiedQuery.Tag:=
       Modifications[j].ModifiedQuery.Tag or TagOrVal;
     Modifications[j].ModifiedQuery.Close;
     Modifications[j].ModifiedQuery.Sql.Text:=QueryText;
     Modifications[j].ModifiedQuery.Open;
   end
   else begin
     // Napisati kod koji prolazi kroz sve upite koji figurisu
   end;
 end;
end;

procedure PrintReport(MasterQuery,DetailQuery:TQuery;ReportForm:Tform;FType:TFormClass);
var
   ZReadOnlyMaster: TQuery;
   ZReadOnlyDetail: TQuery;
   QuickRep1:TQuickRep;
   QRSubDetail1:TQRSubDetail;
begin
  Application.CreateForm(FType,ReportForm);
  ZReadOnlyMaster:=ReportForm.FindComponent('ZReadOnlyMaster') as  TQuery;
  ZReadOnlyDetail:=ReportForm.FindComponent('ZReadOnlyDetail')  as  TQuery;
  if (MasterQuery=DetailQuery) or (DetailQuery=nil) then ZReadOnlyDetail:=nil;
  QuickRep1:=ReportForm.FindComponent('QuickRep1') as TQuickRep;

  if ZReadOnlyMaster<>nil then begin
     ZReadOnlyMaster.SQL:=MasterQuery.SQL;
     ZReadOnlyMaster.Open;
  end;
  if ZReadOnlyDetail<>nil then begin
     ZReadOnlyDetail.SQL:=DetailQuery.SQL;
     ZReadOnlyDetail.Open;
  end
  else begin
    QRSubDetail1:=ReportForm.FindComponent('QRSubDetail')  as  TQRSubDetail;
    if QrSubDetail1<>nil then
      QRSubDetail1.Enabled:=False;
  end;
  if QuickRep1<>nil then begin
     QuickRep1.Print;
  end;
  ReportForm.Free;
end;

procedure PreviewReport(MasterQuery,DetailQuery:TQuery;ReportForm:Tform;FType:TFormClass);
var
   ZReadOnlyMaster: TQuery;
   ZReadOnlyDetail: TQuery;
   QuickRep1:TQuickRep;
   QRSubDetail1:TQRSubDetail;

begin
  Application.CreateForm(FType,ReportForm);
  ZReadOnlyMaster:=ReportForm.FindComponent('ZReadOnlyMaster')  as  TQuery;
  ZReadOnlyDetail:=ReportForm.FindComponent('ZReadOnlyDetail')  as  TQuery;
  if (MasterQuery=DetailQuery) or (DetailQuery=nil) then ZReadOnlyDetail:=nil;
  QuickRep1:=ReportForm.FindComponent('QuickRep1')  as TQuickRep;

  if ZReadOnlyMaster<>nil then begin
     ZReadOnlyMaster.SQL:=MasterQuery.SQL;
     ZReadOnlyMaster.Open;
  end;
  if ZReadOnlyDetail<>nil then begin
     ZReadOnlyDetail.SQL:=DetailQuery.SQL;
     ZReadOnlyDetail.Open;
  end
  else begin
    QRSubDetail1:=ReportForm.FindComponent('QRSubDetail')  as  TQRSubDetail;
    if QrSubDetail1<>nil then
      QRSubDetail1.Enabled:=False;
  end;

  if QuickRep1<>nil then begin
     QuickRep1.Preview;
  end;
  ReportForm.Free;
end;

procedure TdmConnection.dmConnectionCreate(Sender: TObject);
begin
   DataBaseBDE.Connected:=true;
end;

procedure TdmConnection.dmConnectionDestroy(Sender: TObject);
begin
   DataBaseBDE.Connected:=false;
end;

end.
 